------------------------------------------------------------------------------------------------------------------------
-- informer.lua - statistic informers
-- wow addon by Applesinych [k.shabordin@gmail.com]
------------------------------------------------------------------------------------------------------------------------

local GetMoney,GetNetStats,GetFramerate,GetNumAddOns,GetAddOnInfo,GetGuildInfo,GetGuildRosterMOTD,GetNumFriends,
      GetFriendInfo,IsInGuild,GetNumGuildMembers,GetGuildRosterInfo,GetContainerNumSlots,GetGameTime,
      GetNumQuestLogEntries,GetRealZoneText,GetSubZoneText,GuildRoster,UnitXP,UnitXPMax,UnitAttackSpeed,
      UnitAttackPower,UnitStat,GetCritChance,UnitArmor,UnitDefense = 
      GetMoney,GetNetStats,GetFramerate,GetNumAddOns,GetAddOnInfo,GetGuildInfo,GetGuildRosterMOTD,GetNumFriends,
      GetFriendInfo,IsInGuild,GetNumGuildMembers,GetGuildRosterInfo,GetContainerNumSlots,GetGameTime,
      GetNumQuestLogEntries,GetRealZoneText,GetSubZoneText,GuildRoster,UnitXP,UnitXPMax,UnitAttackSpeed,
      UnitAttackPower,UnitStat,GetCritChance,UnitArmor,UnitDefense 
      
            
local DB,util,panel= SNT_INFO.DB,SNT_INFO.util,SNT_INFO.panel

local informer = {}
local placeholder,place_ndx = {},1

local function line2(m1,m2) GameTooltip:AddDoubleLine(m1,m2,0.3,0.8,0.8,0.3,0.6,0.8) end
local function line1(m) GameTooltip:AddLine(m,0.7,0.7,02) end  

function informer:new(name)
   local instance = {}
   instance.pnl = panel:new(name)
   instance.pnl.frame:SetHeight(DB.fontsize+8)
   if(place_ndx > 1) then
      local parent = placeholder[place_ndx-1].pnl.frame
      local distance = parent:GetWidth()+1
      instance.pnl.frame:SetPoint("LEFT",parent,"RIGHT",distance,0)
   else   
      instance.pnl.frame:SetPoint("TOPLEFT",UIParent,"TOPLEFT",22,-2)
   end

   instance.pnl:do_movable_if()
   instance.pnl.frame:SetFrameStrata("LOW")
   placeholder[place_ndx] = instance
   place_ndx = place_ndx+1 
   setmetatable(instance,self)   
   self.__index   = self
   return instance
end 

function informer:add_text(...) self.pnl:add_text(...) end
function informer:point(...) self.pnl:point(...) end
function informer:add_updated_text(text_f,timing) self.pnl:add_update(function() self:add_text(text_f(),true) end,timing) end
function informer:add_tooltip(tt_f) self.pnl:add_tooltip(tt_f) end
function informer:add_event(...) self.pnl:add_event(...) end
function informer:do_movable() self.pnl:do_movable() end
function informer:set_click(...) self.pnl:set_click(...) end

------------------------------------------------------------------------------------------------------------------------

local guildtable,friendtable,guild_str,friend_str,bag_str,loc_str,q_str = {},{},{}

local function get_perf()
   local lag = select(3,GetNetStats())
   local fps = ceil(GetFramerate())
   local mem = collectgarbage("count")
   return util.gradient_s(lag,400,50).."ms "..util.gradient_s(fps,0,45).."fps "..util.memory(mem,40,10)
end

local function show_addons()
   local total,addons,all_mem = 0,{},collectgarbage("count")
    UpdateAddOnMemoryUsage()  
    for i=1,GetNumAddOns(), 1 do  
      if (GetAddOnMemoryUsage(i) > 0 ) then
        memory = GetAddOnMemoryUsage(i)  
        entry = {name=GetAddOnInfo(i),memory =memory}  
        table.insert(addons, entry)  
        total = total + memory  
      end
    end  
    table.sort(addons,function(a,b) return a.memory > b.memory end)  
    line1("click for collect garbage\naddons memory usage:\n")  
   i = 0  
    for _, entry in pairs(addons) do  
         if(entry.name == "_snt_info") then  
            line2("|cffff00ffsnt_info |r",util.memory(entry.memory,2,0.1))
         else
           line2(entry.name,util.memory(entry.memory,2,0.1)) 
         end    
        i = i + 1  
        if i >= 50 then  break  end  
    end  
    line2("\naddons",util.memory(total,30,10))
    line2("blizzard",util.memory(all_mem-total,20,5))
    line2("total\n\n",util.memory(all_mem,50,5))
end

local function get_dura()
   local ndx,durability,d_val,d_max = 0,0
   for slot = 0,19 do
      d_val,d_max = GetInventoryItemDurability(slot)
      if(d_val) then 
         durability = durability + d_val/d_max*100   
         ndx=ndx+1 
      end 
   end
   durability = floor(durability/ndx)
   return "D: "..util.gradient_s(floor(durability),0,100).." % "
end


local function show_guild()
   line1("click for show blizzard guild frame")
   line2("guild :",GetGuildInfo("player")) 
   line2("motd  :",GetGuildRosterMOTD())
   line1("\n")
   for _, val in ipairs(guildtable) do
      line2(format("[%s]  %s%s|r (%s)",util.level_s(val[1]),util.class(val[3]),val[2],val[3]),val[4])
   end
end
local function show_friends()
   line1("click for show blizzard friends frame")
   line2("total friends",GetNumFriends()) 
   line1("\n")
   for _, val in ipairs(friendtable) do
      line2(format("[%s]  %s%s|r (%s)",util.level_s(val[1]),util.class(val[3]),val[2],val[3]),val[4])
   end
end
local function friend_update()
   local total,online = GetNumFriends(),0
   friendtable = {}
   for ndx = 0,total do
      local name,lvl,class,zone,on,st,note = GetFriendInfo(ndx)
      if(on and name) then 
        table.insert(friendtable,{lvl,name,class,zone})
        online = online+1 end 
   end
   friend_str = "FR: "..online.."/"..total
end

local function guild_update()
   local total,online = 0,0
   guildtable = {}
   if IsInGuild() then
      total = GetNumGuildMembers(true)
      for ndx = 0, total do
         name,_,_,lvl,class,zone,_,_,on,_ = GetGuildRosterInfo(ndx)
         if(on and name) then 
            online = online + on 
            table.insert(guildtable,{lvl,name,class,zone})
          end
     end
   end
   guild_str = "GL: "..online.."/"..total
end

local function bag_update() 
   local all_slots,free_slots = 0,0
   for bag = 0,4 do
      local slots = GetContainerNumSlots(bag) 
      local free  = GetContainerNumFreeSlots(bag)
      all_slots   = all_slots + slots
      free_slots  = free_slots + free
   end
   bag_str = "B: "..util.gradient_s(free_slots,0,all_slots).."/"..all_slots
end



local function get_xp () 
   local rest = GetXPExhaustion() or 0
   local xp_str = string.format("XP: %s %% [%0.1fk] |cff66cc33R: %0.1fk|r",
                              util.gradient_s(floor(UnitXP("player")/UnitXPMax("player")*100),0,100),
                              (UnitXPMax("player")-UnitXP("player"))/1024,
                              rest/1024)
   return xp_str
end


------------------------------------------------------------------------------------------------------------------------
local function toggle_frame(frame) if(frame) then if(frame:IsVisible()) then frame:Hide() else frame:Show() end end end


------------------------------------------------------------------------------------------------------------------------

itime = informer:new("snt_time")
itime:add_tooltip(function() local h,m = GetGameTime() line1("") line2("local time",date("%H:%M")) line2("server time",h..":"..m) end)
itime:add_updated_text(function() return date("%H:%M:%S") end,1)

iperf = informer:new("snt_perf")
iperf:add_tooltip(show_addons)
iperf:add_updated_text(get_perf,1)
iperf:set_click(function() collectgarbage("count") end)


imoney = informer:new("snt_money")
imoney:add_tooltip(function() line1("money") end)
imoney:add_updated_text(function() return util.money(GetMoney()) end,1)

ibag = informer:new("snt_bag")
ibag:add_tooltip(function() line1("click for open bags\ntodo: more fuctionality") end)
ibag:add_event("BAG_UPDATE",bag_update)
ibag:add_event("PLAYER_LOGIN",bag_update)
ibag:add_updated_text(function() return bag_str end,1)

idura = informer:new("snt_dura")
idura:add_tooltip(function() line1("durability\ntodo : more functionality") end)
idura:add_updated_text(get_dura,1)

iquest = informer:new("snt_quest")
iquest:add_tooltip(function() line1("click for open questlog\ntodo: more functionality") end)
iquest:add_event("QUEST_LOG_UPDATE",function() q_str = "Q: "..util.gradient_s(select(2,GetNumQuestLogEntries()),25,0).."/25" end)
iquest:add_event("PLAYER_LOGIN",function() q_str = "Q: "..util.gradient_s(select(2,GetNumQuestLogEntries()),25,0).."/25" end)
iquest:add_updated_text(function() return q_str end,1)
iquest:set_click(function() toggle_frame(QuestLogFrame) end)

iloc = informer:new("snt_loc")
iloc:add_tooltip(function() line1("click for open worldmap\ntodo: more location info") end)
iloc:add_event("ZONE_CHANGED_NEW_AREA",function() loc_str = GetRealZoneText().." ["..GetSubZoneText().."]" end)
iloc:add_event("PLAYER_LOGIN",function() loc_str = GetRealZoneText().." ["..GetSubZoneText().."]" end)
iloc:add_updated_text(function() local x,y = GetPlayerMapPosition("player") return loc_str.."|cffffff00 ["..floor(x*100).."."..floor(y*100).."]|r" end,1)
iloc:set_click(function() toggle_frame(WorldMapFrame) end)

ifriend = informer:new("snt_friend")
ifriend:add_tooltip(show_friends)
ifriend:add_event("FRIENDLIST_UPDATE",friend_update)
ifriend:add_event("PLAYER_LOGIN",friend_update)
ifriend:add_updated_text(function() return friend_str end,1)
ifriend:set_click(function() toggle_frame(FriendsFrame) end)

iguild = informer:new("snt_guild")
iguild:add_tooltip(show_guild)
iguild:add_event("GUILD_ROSTER_UPDATE",guild_update)
iguild:add_event("PLAYER_GUILD_UPDATE",guild_update)
iguild:add_event("PLAYER_LOGIN",guild_update)
iguild:add_updated_text(function() if IsInGuild() then GuildRoster() end return guild_str end,1)
iguild:set_click(function() toggle_frame(GuildFrame) end)

iexp = informer:new("snt_exp")
iexp:add_tooltip(function() line2("Player XP",UnitXP("player").."/"..UnitXPMax("player")) end)
iexp:add_updated_text(get_xp,1)





